package com.shadeslider.base 
{
    import com.shadeslider.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.utils.*;
    
    public class CompositeView extends com.shadeslider.base.ComponentView
    {
        public function CompositeView(arg1:flash.display.DisplayObject, arg2:com.shadeslider.base.AbstractModel, arg3:Object)
        {
            super(arg1, arg2, arg3);
            this._children = new Object();
            this.addChildren();
            this.setupChildrenInitListener();
            return;
        }

        private function setupChildrenInitListener():void
        {
            var initCount:int;
            var lTimer:flash.utils.Timer;

            var loc1:*;
            initCount = 0;
            lTimer = null;
            lTimer = new flash.utils.Timer(1000 / 30, 0);
            lTimer.addEventListener(flash.events.TimerEvent.TIMER, function ():void
            {
                var loc1:*=null;
                var loc2:*=0;
                var loc3:*=_children;
                for (loc1 in loc3)
                {
                    initCount = 0;
                    if (_children[loc1].initiated)
                    {
                        var loc4:*;
                        initCount++;
                    }
                    if (initCount != com.shadeslider.utils.ObjectUtils.count(_children))
                    {
                        continue;
                    }
                    dispatchEvent(new com.shadeslider.base.ViewEvent(com.shadeslider.base.ViewEvent.INIT_DEFAULT_CHILDREN));
                    lTimer.stop();
                }
                return;
            })
            lTimer.start();
            return;
        }

        public override function initDefaultAppearance():void
        {
            super.initDefaultAppearance();
            return;
        }

        public override function getChild(arg1:String):com.shadeslider.base.ComponentView
        {
            return this._children[arg1];
        }

        protected function addChildren():void
        {
            return;
        }

        public override function addChild(arg1:String, arg2:com.shadeslider.base.ComponentView):void
        {
            this._children[arg1] = arg2;
            return;
        }

        public function initChildrenDefaultAppearance():void
        {
            var loc1:*=null;
            super.initDefaultAppearance();
            var loc2:*=0;
            var loc3:*=this.children;
            for (loc1 in loc3)
            {
                this.children[loc1].initDefaultAppearance();
            }
            return;
        }

        public override function get children():Object
        {
            return this._children;
        }

        protected var _children:Object;
    }
}
