package com.shadeslider.base 
{
    import flash.display.*;
    import flash.errors.*;
    
    public class ComponentView extends com.shadeslider.base.AbstractView
    {
        public function ComponentView(arg1:flash.display.DisplayObject, arg2:com.shadeslider.base.AbstractModel, arg3:Object=null)
        {
            super();
            this.model = arg2;
            this.stageClip = arg1;
            this.config = arg3;
            this.model.addEventListener(com.shadeslider.base.ModelEvent.UPDATE, update);
            this.model.addEventListener(com.shadeslider.base.ModelEvent.STATE, modelState);
            return;
        }

        public function getChild(arg1:String):com.shadeslider.base.ComponentView
        {
            throw new flash.errors.IllegalOperationError("Get operation not supported");
        }

        public function get _stageClip():*
        {
            return this.stageClip;
        }

        public function initComplete():void
        {
            dispatchEvent(new com.shadeslider.base.ViewEvent(com.shadeslider.base.ViewEvent.INIT_DEFAULT));
            this._initiated = true;
            return;
        }

        public function initDefaultAppearance():void
        {
            return;
        }

        public function get initiated():Boolean
        {
            return this._initiated;
        }

        public function addChild(arg1:String, arg2:com.shadeslider.base.ComponentView):void
        {
            throw new flash.errors.IllegalOperationError("Add operation not supported");
        }

        public function get children():Object
        {
            throw new flash.errors.IllegalOperationError("Get children operation not supported");
        }

        protected var config:Object;

        protected var viewModel:com.shadeslider.base.AbstractModel;

        protected var model:*;

        protected var _initiated:Boolean=false;

        protected var stageClip:*;
    }
}
